Subject: Re: bug#62780: 30.0.50; Redisplay gets slow when using Org tables + show-trailing-whitespace

From: Eli Zaretskii <[email-masked]>
Date: Sat, 29 Apr 2023 11:57:51 +0300

> From: Ihor Radchenko <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 14 Apr 2023 12:28:25 +0000
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> > But to test this idea, I need enough test cases that use the
> > 'composition' property to make sure the property still works after I
> > disable that call.  Can you collect a few test cases which use the
> > 'composition' property, with or without Org tables?  I guess
> > prettify-symbols-mode is one of them, but are there others?  I will
> > then try to find time to test this idea.
> 
> 1. The most obvious is prettify-symbols-mode in Emacs sources
>    Say, (setq-local prettify-symbols-alist '(("!" . ?¬)) M-x
>    prettify-symbols-mode
> 
> 2. https://github.com/integral-dw/org-superstar-mode
>    You can use tests/*.org example files
>    Also, https://github.com/jdtsmith/shakespeare.org has a giant example
>    Org file. And https://github.com/casouri/valign/blob/master/test.org
>    has a number of example tables (though the package itself does not
>    use composition).
> 
> 3. Typing using TeX input method will produce composed glyphs. The same
>    if you set org-pretty-entities to t and then type \alpha, \beta, etc
>    in Org buffers.
> 
> 4. Composing long spans of text might be a reasonable edge case to test.

Thanks, and apologies for the long delay.

I've now installed on master several optimizations related to search
of composable characters by the display engine.  I tested some of the
above scenarios (not all of them), and they seem to work as well as
before.

Do these changes make significant improvements in redisplay speed in
org-table buffers?  If not, can you tell me where are the hot spots
after these changes?

Also, if you see any regressions due to these changes, please report
them.  I will keep this bug open for now.